Collection-Scripts/full-backup.sh.unused

76 lines
2.1 KiB
Plaintext
Executable File

# full-backup.sh.unused
#!/bin/bash
# Use your health check url
HEALTHCHECK_URL="https://healthchecks.io/ping/{uuid}"
dpkg --get-selections > /root/software.list
# Setting this, so the repo does not need to be given on the commandline:
export BORG_REPO=ssh://{user}@{serverip}/share/Backup
# some helpers and error handling:
info() { printf "\n%s %s\n\n" "$( date )" "$*" >&2; }
trap 'echo $( date ) Backup interrupted >&2; exit 2' INT TERM
info "Starting backup"
# Backup the most important directories into an archive named after
# the machine this script is currently running on:
borg create \
--verbose \
--filter AME \
--list \
--show-rc \
--stats \
--compression lz4 \
--exclude '*/cache/*' \
--exclude '*.cache*' \
--exclude '*/.DS_Store' \
--exclude '*.DS_Store' \
\
::'{hostname}-{now}' \
/var/www/doggo.kaufen \
/mailcow-backup-external \
/root \
/etc/letsencrypt \
backup_exit=$?
info "Pruning repository"
# Use the `prune` subcommand to maintain 7 daily, 4 weekly and 6 monthly
# archives of THIS machine. The '{hostname}-' prefix is very important to
# limit prune's operation to this machine's archives and not apply to
# other machines' archives also:
borg prune \
--list \
--prefix '{hostname}-' \
--show-rc \
--keep-daily 7 \
--keep-weekly 4 \
--keep-monthly 6 \
prune_exit=$?
# use highest exit code as global exit code
global_exit=$(( backup_exit > prune_exit ? backup_exit : prune_exit ))
if [ ${global_exit} -eq 1 ];
then
info "Backup and/or Prune finished with a warning"
fi
if [ ${global_exit} -gt 1 ];
then
info "Backup and/or Prune finished with an error"
fi
if [ ${global_exit} -eq 0 ];
then
curl -fsS --retry 3 "$HEALTHCHECK_URL" > /dev/null
fi
exit ${global_exit}